/**
  ******************************************************************************
  * @file    TMR/TimeBase/apm32f10x_it.c 
  * @author  IOT Development Team
  * @version V1.0.0
  * @date    10-January-2020
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all exceptions handler and peripherals
  *          interrupt service routine.
  ******************************************************************************
  */ 

/* Includes ------------------------------------------------------------------*/
#include "apm32f10x_it.h"

/** @addtogroup APM32F10x_StdPeriph_Examples
  * @{
  */

/** @addtogroup TMR_TimeBase
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
uint16_t capture = 0;
extern __IO uint16_t CCR1_Val;
extern __IO uint16_t CCR2_Val;
extern __IO uint16_t CCR3_Val;
extern __IO uint16_t CCR4_Val;

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            Cortex-M3 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief  This function handles NMI exception.
  * @param  None
  * @retval None
  */
void NMI_Handler(void)
{
}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {}
}

/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
void MemManage_Handler(void)
{
  /* Go to infinite loop when Memory Manage exception occurs */
  while (1)
  {}
}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
void BusFault_Handler(void)
{
  /* Go to infinite loop when Bus Fault exception occurs */
  while (1)
  {}
}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
void UsageFault_Handler(void)
{
  /* Go to infinite loop when Usage Fault exception occurs */
  while (1)
  {}
}

/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
void DebugMon_Handler(void)
{}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
void SVC_Handler(void)
{}

/**
  * @brief  This function handles PendSV_Handler exception.
  * @param  None
  * @retval None
  */
void PendSV_Handler(void)
{}

/**
  * @brief  This function handles SysTick Handler.
  * @param  None
  * @retval None
  */
void SysTick_Handler(void)
{}

/******************************************************************************/
/*            APM32F10x Peripherals Interrupt Handlers                        */
/******************************************************************************/

/**
  * @brief  This function handles TMR2 global interrupt request.
  * @param  None
  * @retval None
  */
void TMR2_IRQHandler(void)
{
  if (TMR_RreadIntFlag(TMR2, TMR_TI_CH1) != RESET)
  {
    TMR_ClearIntFlag(TMR2, TMR_TI_CH1);

    /* Pin PC.06 toggling with frequency = 73.24 Hz */
    GPIO_WriteOutputBit(GPIOC, GPIO_PIN_6, (BitAction)(1 - GPIO_ReadOutputBit(GPIOC, GPIO_PIN_6)));
    capture = TMR_ReadCaputer1(TMR2);
    TMR_SetCompare1(TMR2, capture + CCR1_Val);
  }
  else if (TMR_RreadIntFlag(TMR2, TMR_TI_CH2) != RESET)
  {
    TMR_ClearIntFlag(TMR2, TMR_TI_CH2);

    /* Pin PC.07 toggling with frequency = 109.8 Hz */
    GPIO_WriteOutputBit(GPIOC, GPIO_PIN_7, (BitAction)(1 - GPIO_ReadOutputBit(GPIOC, GPIO_PIN_7)));
    capture = TMR_ReadCaputer2(TMR2);
    TMR_SetCompare2(TMR2, capture + CCR2_Val);
  }
  else if (TMR_RreadIntFlag(TMR2, TMR_TI_CH3) != RESET)
  {
    TMR_ClearIntFlag(TMR2, TMR_TI_CH3);

    /* Pin PC.08 toggling with frequency = 219.7 Hz */
    GPIO_WriteOutputBit(GPIOC, GPIO_PIN_8, (BitAction)(1 - GPIO_ReadOutputBit(GPIOC, GPIO_PIN_8)));
    capture = TMR_ReadCaputer3(TMR2);
    TMR_SetCompare3(TMR2, capture + CCR3_Val);
  }
  else
  {
    TMR_ClearIntFlag(TMR2, TMR_TI_CH4);

    /* Pin PC.09 toggling with frequency = 439.4 Hz */
    GPIO_WriteOutputBit(GPIOC, GPIO_PIN_9, (BitAction)(1 - GPIO_ReadOutputBit(GPIOC, GPIO_PIN_9)));
    capture = TMR_ReadCaputer4(TMR2);
    TMR_SetCompare4(TMR2, capture + CCR4_Val);
  }
}

/******************************************************************************/
/*                 APM32F10x Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_apm32f10x_xx.s).                                            */
/******************************************************************************/

/**
  * @brief  This function handles PPP interrupt request.
  * @param  None
  * @retval None
  */
/*void PPP_IRQHandler(void)
{
}*/

/**
  * @}
  */ 

/**
  * @}
  */ 

